var midcontextmenu = {

  MID_TAB_URL : "chrome://mid/content/mid.xul?tab",
  retries : 0, 
  mid_prefsvc : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
  
  onLoad: function() {
    // initialization code
    midcontextmenu.initialized = true;
    midcontextmenu.strings = document.getElementById("midcontextmenu-strings");
    document.getElementById("contentAreaContextMenu")
            .addEventListener("popupshowing", function(e) { midcontextmenu.showContextMenu(e); }, false);
  },

  showContextMenu: function(event) {

      var myitem = document.getElementById("context-midcontextmenu");
      midcontextmenu.retries = 0;
      if ((midcontextmenu.getTextSelected().length == 0) || !midcontextmenu.isContextEnabled()) {
          myitem.hidden = true;
      } else {
          myitem.hidden = false;
      }
  },

  onMenuItemCommand: function(e) {

        function fibonacci(n) {
            if (n==1 || n==2 ) {
               return 1;
            }
            return fibonacci(n-1) + fibonacci(n-2);
        }

       var timer1 = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);                                                                  
       var timer2 = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);                                                                  
        
       var callbackFunction1  = {
            notify: function(timer1) {
              midtaskortoolsmenu.newMIDWindow();
            }
        }
       var callbackFunction2 = {
            notify: function(timer2) {
               midcontextmenu.onMenuItemCommand()
            }
        }


        var selText = midcontextmenu.getTextSelected();
        var tab = null;  tab = midcontextmenu.findMidTab();

        if (tab) {
           var b = gBrowser.getBrowserForTab(tab); 
           win = b.contentWindow;
           win.domHelper.inputElement.value = selText;
           win.mid_mud.lookup.lookupWord();
           return;
        }

        const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
        var windowMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
        windowMediator = windowMediator.QueryInterface(nsIWindowMediator);
        var win = windowMediator.getMostRecentWindow("mid:main");

        if (!win || !win.domHelper) {
            midcontextmenu.retries = midcontextmenu.retries + 1;
            if (midcontextmenu.retries > 10) {
                midcontextmenu.retries = 0; 
                alert("mid not found :(");
                return;                            // couldn't start mid
            } else { 
                if (midcontextmenu.retries == 1) {
                    timer1.initWithCallback(callbackFunction1, 15, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
                }
            }
            var szam = 300 + fibonacci(midcontextmenu.retries)*100 ;
            timer2.initWithCallback(callbackFunction2, szam , Components.interfaces.nsITimer.TYPE_ONE_SHOT);
            return;
        } else {
            win.domHelper.inputElement.value = selText;
            win.mid_mud.lookup.lookupWord();
            win.focus();
        }
 
        midcontextmenu.retries = 0;

  },

  getTextSelected: function() {

        var selection = "";
        var node = document.popupNode;
        var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');

        if ((node instanceof HTMLTextAreaElement) || ((node instanceof HTMLInputElement) && (node.type == "text")))  {
             selection = node.value.substring(node.selectionStart, node.selectionEnd);
        } else {
          selection = focusedWindow.getSelection().toString();
        }

   return selection;

  },

  isContextEnabled : function() {
      if (midcontextmenu.mid_prefsvc.getPrefType("extensions.mid.menus.sendfromcontext") == midcontextmenu.mid_prefsvc.PREF_BOOL) {
          if (midcontextmenu.mid_prefsvc.getBoolPref("extensions.mid.menus.sendfromcontext")) {
              return true;
          }
      }
      return false;
  },

  findMidTab : function() {
  // Look for an existing tab
      var tab = false;
      var numTabs = gBrowser.browsers.length;
      for(var index = 0; index < numTabs; index++) {
          var currentBrowser = gBrowser.getBrowserAtIndex(index);
          if(this.MID_TAB_URL == currentBrowser.currentURI.spec) {
             tab = (gBrowser.tabs ? gBrowser.tabs : gBrowser.mTabs)[index];
             break;
          }
     } 

     return tab;
  }



};
window.addEventListener("load", function(e) { midcontextmenu.onLoad(e); }, false);
